<?php

error_reporting(0);
if (isset($debug) && $debug) {
  error_reporting(E_ALL);
  ini_set('display_errors', 0);
  ini_set('log_errors', 'On');
}

require_once('workflows.php');

$w = new Workflows();

/**
 * [workflow_print description]
 * @return [type] [description]
 */
function workflow_print() {
  global $w;

  if (!count($w->results())) {
    $w->result( 'alfred', 'alfredapp', 'No results found.', '', 'icon.png', 'no' );
  }

  echo $w->toxml($w->results());
}

/**
 * Creates a cache file, fetches information and caches the result as JSON for 24 hours.
 */
function set_get_cache($url = 'http://bukk.it', $filename = 'cache.json') {
  global $w;

  $contents = $w->read($filename);
  if (empty($contents) || (time() > filemtime($w->data() . '/' . $filename) + (3600 * 24))) {
    $contents = file_get_contents($url);
    preg_match_all('/<a href=\"([^\"]*)\">(.*)<\/a>/iU', $contents, $hrefs);
    $contents = array_splice($hrefs[1], 4, count($hrefs[1]));
    $w->write($contents, $filename);
    $contents = $w->read($filename);
  }

  return $contents;
}

$query = urlencode("{query}");

/**
 * [bukkit_search description]
 * @param  [type] $query [description]
 * @return [type]        [description]
 */
function bukkit_search($query) {
  global $w;

  $contents = set_get_cache();

  foreach ($contents as $key => $item) {
    if (strpos($item, $query) !== FALSE) {
      $w->result(
        $query,
        'http://bukk.it/' . $item,
        $item,
        'http://bukk.it/' . $item,
        'icon.png',
        'yes'
      );
    }
  }

  workflow_print();
}

/**
 * [bukkit_random description]
 * @return [type] [description]
 */
function bukkit_random() {
  $contents = set_get_cache();
  $item = array_rand($contents);
  echo 'http://bukk.it/' . $contents[$item];
}
